function [Epizodok,EpizodHosszak,EpizodokSzlo,EpizodIdok]=EpizodKereses1(SzimbSor,SzimbIndex,AblakHossz,AblakKapac);


%Az Epizodkereses1 ugyanugy mukodik, mint az Epizodkereses, csak az
%eredetinel a teljes szimblumsor - res szimblumokkal - benne van, itt az
%res szimblumok nlkli szimblumsor. Viszont itt van egy SzimbIndex
%mellette, az egyes szimblumok idejvel (Egyszeruen 1...Neredeti, persze
%kihagysokkal).


N=size(SzimbSor,1);

%kimeneti parametrek
Epizodok=['###'];
EpizodHosszak=0;
EpizodokSzlo=0;
EpizodIdok(1).StartIdok=[];
%
%
EpizodSzam=0; % hny epizdot talltunk eddig
%Az aktulis epizdvizsgl ablakban lvo szimblumok adatai
AktEpizodokIdeje(1,1)=0;
AktEpizod=[];

kk=0;
while kk<=N 
    %Ha kk==N, akkor az utols szimblumot dolgozzuk fel, el kell tennnk
    %az utols epizdot. Ezt knyszertjk akvetkez if else gval.
    kk=kk+1;
    if kk<=N
        UjSzimb=SzimbSor(kk,:);
        UjSzimbIndex=SzimbIndex(kk);
    else
        UjSzimb='XXX';
        UjSzimbIndex=SzimbIndex(end)+2*AblakHossz;   %knyszertjk, hogy az utols epizdot dolgozza fel
    end
    %Az ablakhosszt (ido) lpjk tl (AktEpizodokIdeje(1)==0 jelzi, hogy ha res az AktEpizod, teht az els?
    %szimblumot talltuk meg)
    if (AktEpizodokIdeje(1)~=0) && ((UjSzimbIndex-AktEpizodokIdeje(1,1))>AblakHossz)  %AblakHosszAblakHossz+++++++++
        %AktEpizodEllenorzes
        AktEpizodVekt=reshape(AktEpizod',1,3*size(AktEpizod,1));
        if EpizodSzam==0   %az elso epizdot talltuk meg
%             AktEpizod
            Epizodok=['###';AktEpizod;'###'];
            EpizodokSzlo(1,1)=1;
            EpizodHosszak(1,1)=size(AktEpizod,1);   %az aktulisan eltrolt epizd hossza
            EpizodSzam=1;
            EpizodIdok(1).StartIdok=[AktEpizodokIdeje(1)];
        else   %mr talltunk rgebben is epizdokat, meg kell nznnk, jat taltunk-e?
            MarVoltIlyenFlag=0;
            EpizodStartMutato=1;
            jj=0;
            while jj<EpizodSzam
                jj=jj+1;
                EpizodVegMutato=EpizodStartMutato+1;
                while not(strcmp(Epizodok(EpizodVegMutato,:),'###'))  %'###' az elvlaszt jel a kt epizd kzt
                    EpizodVegMutato=EpizodVegMutato+1;
                end
                VizsgaltEpizod=Epizodok(EpizodStartMutato+1:EpizodVegMutato-1,:);
                VizsgaltEpizodVekt=reshape(VizsgaltEpizod',1,3*size(VizsgaltEpizod,1));
                if strcmp(AktEpizodVekt,VizsgaltEpizodVekt)
                    EpizodokSzlo(jj,1)=EpizodokSzlo(jj,1)+1;  %az jraelokerlt epizd szmlljt nveljk eggyel
                    EpizodIdok(jj).StartIdok=[EpizodIdok(jj).StartIdok;AktEpizodokIdeje(1)]; %az adott - mr ismert - epizd kezd?
                                %idopontjaihoz hozzvesszk a most talltat
                    MarVoltIlyenFlag=1;
                    jj=EpizodSzam+1;    %kilps a while ciklusbl
                end
                EpizodStartMutato=EpizodVegMutato;   %kvetkez? mr felfedezett epizd el?tti '###'-ra mutat
            end   % while jj<EpizodSzam
            if not(MarVoltIlyenFlag)   %nem volt mg ilyen epizd
%             AktEpizod
                Epizodok=[Epizodok;AktEpizod;'###'];
                EpizodSzam=EpizodSzam+1;
                EpizodHosszak(EpizodSzam,1)=size(AktEpizod,1);   %az aktulisan eltrolt epizd hossza
                EpizodokSzlo(EpizodSzam,1)=1;
                EpizodIdok(EpizodSzam).StartIdok=[AktEpizodokIdeje(1)];
            end
        end
        %Az epizdvizsgl ablakkal lpnk, kivesszk a legrgebbi
        %szimblumo(ka)t s betesszk az jat
        % Az AktEpizod-bl kiszedjk a rgi szimblumokat, ami kiesnek az
        % ablakbl
        TmpInd=(UjSzimbIndex-AktEpizodokIdeje(:,1)<=AblakHossz);
        if not(any(TmpInd)) %ha mindegyik szimblum kiesik az ablakbl, tl
                                        %rgiek
            AktEpizod=UjSzimb;
            AktEpizodokIdeje=UjSzimbIndex;
        else    %tbb epizd van benne, meg kell vizsglni
            AktEpizod=[AktEpizod(TmpInd,:);UjSzimb];
            AktEpizodokIdeje=AktEpizodokIdeje(TmpInd,1);  %lptetjk 1-el
            AktEpizodokIdeje(length(AktEpizodokIdeje)+1,1)=UjSzimbIndex; %vgre tesszk az j idopontot
        end
                                                  %AblakHosszAblakHossz+++++++++++++++++++++++++++
    %ablak kapacitst lpnnk tl
    elseif (size(AktEpizod,1)+1>AblakKapac)   %AblakKapacAblakKapac------------------------
        %AktEpizodEllenorzes
        AktEpizodVekt=reshape(AktEpizod',1,3*size(AktEpizod,1));
        if EpizodSzam==0   %az elso epizdot talltuk meg
%             AktEpizod
            Epizodok=['###';AktEpizod;'###'];
            EpizodHosszak(1,1)=size(AktEpizod,1);   %az aktulisan eltrolt epizd hossza
            EpizodokSzlo(1,1)=1;
            EpizodSzam=1;
            EpizodIdok(1).StartIdok=[AktEpizodokIdeje(1)]; %az adott - mr ismert - epizd kezd?
                                %idopontjaihoz hozzvesszk a most talltat
        else   %mr talltunk rgebben is epizdokat, meg kell nznnk, jat taltunk-e?
            MarVoltIlyenFlag=0;
            EpizodStartMutato=1;
            jj=0;
            while jj<EpizodSzam
                jj=jj+1;
                EpizodVegMutato=EpizodStartMutato+1;
                while not(strcmp(Epizodok(EpizodVegMutato,:),'###'))
                    EpizodVegMutato=EpizodVegMutato+1;
                end
                VizsgaltEpizod=Epizodok(EpizodStartMutato+1:EpizodVegMutato-1,:);
                VizsgaltEpizodVekt=reshape(VizsgaltEpizod',1,3*size(VizsgaltEpizod,1));
                if strcmp(AktEpizodVekt,VizsgaltEpizodVekt)
                    EpizodokSzlo(jj,1)=EpizodokSzlo(jj,1)+1;  %az jraelokerlt epizd szmlljt nveljk eggyel
                    EpizodIdok(jj).StartIdok=[EpizodIdok(jj).StartIdok;AktEpizodokIdeje(1)]; %az adott - mr ismert - epizd kezd?
                                %id?pontjaihoz hozzvesszk a most talltat
                    MarVoltIlyenFlag=1;
                    jj=EpizodSzam+1;    %kilps a while ciklusbl
                end
                EpizodStartMutato=EpizodVegMutato;   %kvetkez? mr felfedezett epizd
            end   % while jj<EpizodSzam
            if not(MarVoltIlyenFlag)   %nem volt mg ilyen epizd
%             AktEpizod
                Epizodok=[Epizodok;AktEpizod;'###'];
                EpizodSzam=EpizodSzam+1;
                EpizodHosszak(EpizodSzam,1)=size(AktEpizod,1);   %az aktulisan eltrolt epizd hossza
                EpizodokSzlo(EpizodSzam,1)=1;
                EpizodIdok(EpizodSzam).StartIdok=[AktEpizodokIdeje(1)]; %az adott - mr ismert - epizd kezd?
                                %idopontjaihoz hozzvesszk a most talltat
            end
        end
        % Az AktEpizod-bl kiszedjk az elso szimblumot s betesszk az jat
        AktEpizod=[AktEpizod(2:end,:);UjSzimb];
        AktEpizodokIdeje=AktEpizodokIdeje(2:end);
        AktEpizodokIdeje(length(AktEpizodokIdeje)+1)=UjSzimbIndex;

% mg minden szempontbl "belefr" az ablakba
    else      %AblakKapacAblakKapacAblakKapacAblakKapacAblakKapac------------------------
        AktEpizod=[AktEpizod;UjSzimb];
        if AktEpizodokIdeje(1,1)==0
            AktEpizodokIdeje(1,1)=UjSzimbIndex;
        else
            AktEpizodokIdeje(length(AktEpizodokIdeje)+1,1)=UjSzimbIndex;
        end
    end    
end

